<!doctype html>

<html>
<head>
  <link rel="shortcut icon" href="static/images/favicon.ico" type="image/x-icon">
  <title>jsloader.js (Closure Library API Documentation - JavaScript)</title>
  <link rel="stylesheet" href="static/css/base.css">
  <link rel="stylesheet" href="static/css/doc.css">
  <link rel="stylesheet" href="static/css/sidetree.css">
  <link rel="stylesheet" href="static/css/prettify.css">

  <script>
     var _staticFilePath = "static/";
     var _typeTreeName = "goog";
     var _fileTreeName = "Source";
  </script>

  <script src="static/js/doc.js">
  </script>


  <meta charset="utf8">
</head>

<body onload="grokdoc.onLoad();">

<div id="header">
  <div class="g-section g-tpl-50-50 g-split">
    <div class="g-unit g-first">
      <a id="logo" href="index.html">Closure Library API Documentation</a>
    </div>

    <div class="g-unit">
      <div class="g-c">
        <strong>Go to class or file:</strong>
        <input type="text" id="ac">
      </div>
    </div>
  </div>
</div>

<div class="clear"></div>

<h2><a href="local_closure_goog_net_jsloader.js.html">jsloader.js</a></h2>

<pre class="prettyprint lang-js">
<a name="line1"></a>// Copyright 2011 The Closure Library Authors. All Rights Reserved.
<a name="line2"></a>//
<a name="line3"></a>// Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
<a name="line4"></a>// you may not use this file except in compliance with the License.
<a name="line5"></a>// You may obtain a copy of the License at
<a name="line6"></a>//
<a name="line7"></a>//      http://www.apache.org/licenses/LICENSE-2.0
<a name="line8"></a>//
<a name="line9"></a>// Unless required by applicable law or agreed to in writing, software
<a name="line10"></a>// distributed under the License is distributed on an &quot;AS-IS&quot; BASIS,
<a name="line11"></a>// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
<a name="line12"></a>// See the License for the specific language governing permissions and
<a name="line13"></a>// limitations under the License.
<a name="line14"></a>
<a name="line15"></a>/**
<a name="line16"></a> * @fileoverview A utility to load JavaScript files via DOM script tags.
<a name="line17"></a> * Refactored from goog.net.Jsonp. Works cross-domain.
<a name="line18"></a> *
<a name="line19"></a> */
<a name="line20"></a>
<a name="line21"></a>goog.provide(&#39;goog.net.jsloader&#39;);
<a name="line22"></a>goog.provide(&#39;goog.net.jsloader.Error&#39;);
<a name="line23"></a>goog.provide(&#39;goog.net.jsloader.ErrorCode&#39;);
<a name="line24"></a>goog.provide(&#39;goog.net.jsloader.Options&#39;);
<a name="line25"></a>
<a name="line26"></a>goog.require(&#39;goog.array&#39;);
<a name="line27"></a>goog.require(&#39;goog.async.Deferred&#39;);
<a name="line28"></a>goog.require(&#39;goog.debug.Error&#39;);
<a name="line29"></a>goog.require(&#39;goog.dom&#39;);
<a name="line30"></a>goog.require(&#39;goog.dom.TagName&#39;);
<a name="line31"></a>
<a name="line32"></a>
<a name="line33"></a>/**
<a name="line34"></a> * The name of the property of goog.global under which the JavaScript
<a name="line35"></a> * verification object is stored by the loaded script.
<a name="line36"></a> * @type {string}
<a name="line37"></a> * @private
<a name="line38"></a> */
<a name="line39"></a>goog.net.jsloader.GLOBAL_VERIFY_OBJS_ = &#39;closure_verification&#39;;
<a name="line40"></a>
<a name="line41"></a>
<a name="line42"></a>/**
<a name="line43"></a> * The default length of time, in milliseconds, we are prepared to wait for a
<a name="line44"></a> * load request to complete.
<a name="line45"></a> * @type {number}
<a name="line46"></a> */
<a name="line47"></a>goog.net.jsloader.DEFAULT_TIMEOUT = 5000;
<a name="line48"></a>
<a name="line49"></a>
<a name="line50"></a>/**
<a name="line51"></a> * Optional parameters for goog.net.jsloader.send.
<a name="line52"></a> * timeout: The length of time, in milliseconds, we are prepared to wait
<a name="line53"></a> *     for a load request to complete. Default it 5 seconds.
<a name="line54"></a> * document: The HTML document under which to load the JavaScript. Default is
<a name="line55"></a> *     the current document.
<a name="line56"></a> * cleanupWhenDone: If true clean up the script tag after script completes to
<a name="line57"></a> *     load. This is important if you just want to read data from the JavaScript
<a name="line58"></a> *     and then throw it away. Default is false.
<a name="line59"></a> *
<a name="line60"></a> * @typedef {{
<a name="line61"></a> *   timeout: (number|undefined),
<a name="line62"></a> *   document: (HTMLDocument|undefined),
<a name="line63"></a> *   cleanupWhenDone: (boolean|undefined)
<a name="line64"></a> * }}
<a name="line65"></a> */
<a name="line66"></a>goog.net.jsloader.Options;
<a name="line67"></a>
<a name="line68"></a>
<a name="line69"></a>/**
<a name="line70"></a> * Scripts (URIs) waiting to be loaded.
<a name="line71"></a> * @type {Array.&lt;string&gt;}
<a name="line72"></a> * @private
<a name="line73"></a> */
<a name="line74"></a>goog.net.jsloader.scriptsToLoad_ = [];
<a name="line75"></a>
<a name="line76"></a>
<a name="line77"></a>/**
<a name="line78"></a> * Loads and evaluates the JavaScript files at the specified URIs, guaranteeing
<a name="line79"></a> * the order of script loads.
<a name="line80"></a> *
<a name="line81"></a> * Because we have to load the scripts in serial (load script 1, exec script 1,
<a name="line82"></a> * load script 2, exec script 2, and so on), this will be slower than doing
<a name="line83"></a> * the network fetches in parallel.
<a name="line84"></a> *
<a name="line85"></a> * If you need to load a large number of scripts but dependency order doesn&#39;t
<a name="line86"></a> * matter, you should just call goog.net.jsloader.load N times.
<a name="line87"></a> *
<a name="line88"></a> * If you need to load a large number of scripts on the same domain,
<a name="line89"></a> * you may want to use goog.module.ModuleLoader.
<a name="line90"></a> *
<a name="line91"></a> * @param {Array.&lt;string&gt;} uris The URIs to load.
<a name="line92"></a> * @param {goog.net.jsloader.Options=} opt_options Optional parameters. See
<a name="line93"></a> *     goog.net.jsloader.options documentation for details.
<a name="line94"></a> */
<a name="line95"></a>goog.net.jsloader.loadMany = function(uris, opt_options) {
<a name="line96"></a>  // Loading the scripts in serial introduces asynchronosity into the flow.
<a name="line97"></a>  // Therefore, there are race conditions where client A can kick off the load
<a name="line98"></a>  // sequence for client B, even though client A&#39;s scripts haven&#39;t all been
<a name="line99"></a>  // loaded yet.
<a name="line100"></a>  //
<a name="line101"></a>  // To work around this issue, all module loads share a queue.
<a name="line102"></a>  if (!uris.length) {
<a name="line103"></a>    return;
<a name="line104"></a>  }
<a name="line105"></a>
<a name="line106"></a>  var isAnotherModuleLoading = goog.net.jsloader.scriptsToLoad_.length;
<a name="line107"></a>  goog.array.extend(goog.net.jsloader.scriptsToLoad_, uris);
<a name="line108"></a>  if (isAnotherModuleLoading) {
<a name="line109"></a>    // jsloader is still loading some other scripts.
<a name="line110"></a>    // In order to prevent the race condition noted above, we just add
<a name="line111"></a>    // these URIs to the end of the scripts&#39; queue and return.
<a name="line112"></a>    return;
<a name="line113"></a>  }
<a name="line114"></a>
<a name="line115"></a>  uris = goog.net.jsloader.scriptsToLoad_;
<a name="line116"></a>  var popAndLoadNextScript = function() {
<a name="line117"></a>    var uri = uris.shift();
<a name="line118"></a>    var deferred = goog.net.jsloader.load(uri, opt_options);
<a name="line119"></a>    if (uris.length) {
<a name="line120"></a>      deferred.addBoth(popAndLoadNextScript);
<a name="line121"></a>    }
<a name="line122"></a>  };
<a name="line123"></a>  popAndLoadNextScript();
<a name="line124"></a>};
<a name="line125"></a>
<a name="line126"></a>
<a name="line127"></a>/**
<a name="line128"></a> * Loads and evaluates a JavaScript file.
<a name="line129"></a> * When the script loads, a user callback is called.
<a name="line130"></a> * It is the client&#39;s responsibility to verify that the script ran successfully.
<a name="line131"></a> *
<a name="line132"></a> * @param {string} uri The URI of the JavaScript.
<a name="line133"></a> * @param {goog.net.jsloader.Options=} opt_options Optional parameters. See
<a name="line134"></a> *     goog.net.jsloader.Options documentation for details.
<a name="line135"></a> * @return {!goog.async.Deferred} The deferred result, that may be used to add
<a name="line136"></a> *     callbacks and/or cancel the transmission.
<a name="line137"></a> *     The error callback will be called with a single goog.net.jsloader.Error
<a name="line138"></a> *     parameter.
<a name="line139"></a> */
<a name="line140"></a>goog.net.jsloader.load = function(uri, opt_options) {
<a name="line141"></a>  var options = opt_options || {};
<a name="line142"></a>  var doc = options.document || document;
<a name="line143"></a>
<a name="line144"></a>  var script = goog.dom.createElement(goog.dom.TagName.SCRIPT);
<a name="line145"></a>  var request = {script_: script, timeout_: undefined};
<a name="line146"></a>  var deferred = new goog.async.Deferred(goog.net.jsloader.cancel_, request);
<a name="line147"></a>
<a name="line148"></a>  // Set a timeout.
<a name="line149"></a>  var timeout = null;
<a name="line150"></a>  var timeoutDuration = goog.isDefAndNotNull(options.timeout) ?
<a name="line151"></a>      options.timeout : goog.net.jsloader.DEFAULT_TIMEOUT;
<a name="line152"></a>  if (timeoutDuration &gt; 0) {
<a name="line153"></a>    timeout = window.setTimeout(function() {
<a name="line154"></a>      goog.net.jsloader.cleanup_(script, true);
<a name="line155"></a>      deferred.errback(new goog.net.jsloader.Error(
<a name="line156"></a>          goog.net.jsloader.ErrorCode.TIMEOUT,
<a name="line157"></a>          &#39;Timeout reached for loading script &#39; + uri));
<a name="line158"></a>    }, timeoutDuration);
<a name="line159"></a>    request.timeout_ = timeout;
<a name="line160"></a>  }
<a name="line161"></a>
<a name="line162"></a>  // Hang the user callback to be called when the script completes to load.
<a name="line163"></a>  // NOTE(user): This callback will be called in IE even upon error. In any
<a name="line164"></a>  // case it is the client&#39;s responsibility to verify that the script ran
<a name="line165"></a>  // successfully.
<a name="line166"></a>  script.onload = script.onreadystatechange = function() {
<a name="line167"></a>    if (!script.readyState || script.readyState == &#39;loaded&#39; ||
<a name="line168"></a>        script.readyState == &#39;complete&#39;) {
<a name="line169"></a>      var removeScriptNode = options.cleanupWhenDone || false;
<a name="line170"></a>      goog.net.jsloader.cleanup_(script, removeScriptNode, timeout);
<a name="line171"></a>      deferred.callback(null);
<a name="line172"></a>    }
<a name="line173"></a>  };
<a name="line174"></a>
<a name="line175"></a>  // Add an error callback.
<a name="line176"></a>  // NOTE(user): Not supported in IE.
<a name="line177"></a>  script.onerror = function() {
<a name="line178"></a>    goog.net.jsloader.cleanup_(script, true, timeout);
<a name="line179"></a>    deferred.errback(new goog.net.jsloader.Error(
<a name="line180"></a>        goog.net.jsloader.ErrorCode.LOAD_ERROR,
<a name="line181"></a>        &#39;Error while loading script &#39; + uri));
<a name="line182"></a>  };
<a name="line183"></a>
<a name="line184"></a>  // Add the script element to the document.
<a name="line185"></a>  goog.dom.setProperties(script, {
<a name="line186"></a>    &#39;type&#39;: &#39;text/javascript&#39;,
<a name="line187"></a>    &#39;charset&#39;: &#39;UTF-8&#39;,
<a name="line188"></a>    // NOTE(user): Safari never loads the script if we don&#39;t set
<a name="line189"></a>    // the src attribute before appending.
<a name="line190"></a>    &#39;src&#39;: uri
<a name="line191"></a>  });
<a name="line192"></a>  var scriptParent = goog.net.jsloader.getScriptParentElement_(doc);
<a name="line193"></a>  scriptParent.appendChild(script);
<a name="line194"></a>
<a name="line195"></a>  return deferred;
<a name="line196"></a>};
<a name="line197"></a>
<a name="line198"></a>
<a name="line199"></a>/**
<a name="line200"></a> * Loads a JavaScript file and verifies it was evaluated successfully, using a
<a name="line201"></a> * verification object.
<a name="line202"></a> * The verification object is set by the loaded JavaScript at the end of the
<a name="line203"></a> * script.
<a name="line204"></a> * We verify this object was set and return its value in the success callback.
<a name="line205"></a> * If the object is not defined we trigger an error callback.
<a name="line206"></a> *
<a name="line207"></a> * @param {string} uri The URI of the JavaScript.
<a name="line208"></a> * @param {string} verificationObjName The name of the verification object that
<a name="line209"></a> *     the loaded script should set.
<a name="line210"></a> * @param {goog.net.jsloader.Options} options Optional parameters. See
<a name="line211"></a> *     goog.net.jsloader.Options documentation for details.
<a name="line212"></a> * @return {!goog.async.Deferred} The deferred result, that may be used to add
<a name="line213"></a> *     callbacks and/or cancel the transmission.
<a name="line214"></a> *     The success callback will be called with a single parameter containing
<a name="line215"></a> *     the value of the verification object.
<a name="line216"></a> *     The error callback will be called with a single goog.net.jsloader.Error
<a name="line217"></a> *     parameter.
<a name="line218"></a> */
<a name="line219"></a>goog.net.jsloader.loadAndVerify = function(uri, verificationObjName, options) {
<a name="line220"></a>  // Define the global objects variable.
<a name="line221"></a>  if (!goog.global[goog.net.jsloader.GLOBAL_VERIFY_OBJS_]) {
<a name="line222"></a>    goog.global[goog.net.jsloader.GLOBAL_VERIFY_OBJS_] = {};
<a name="line223"></a>  }
<a name="line224"></a>  var verifyObjs = goog.global[goog.net.jsloader.GLOBAL_VERIFY_OBJS_];
<a name="line225"></a>
<a name="line226"></a>  // Verify that the expected object does not exist yet.
<a name="line227"></a>  if (goog.isDef(verifyObjs[verificationObjName])) {
<a name="line228"></a>    // TODO(user): Error or reset variable?
<a name="line229"></a>    return goog.async.Deferred.fail(new goog.net.jsloader.Error(
<a name="line230"></a>        goog.net.jsloader.ErrorCode.VERIFY_OBJECT_ALREADY_EXISTS,
<a name="line231"></a>        &#39;Verification object &#39; + verificationObjName + &#39; already defined.&#39;));
<a name="line232"></a>  }
<a name="line233"></a>
<a name="line234"></a>  // Send request to load the JavaScript.
<a name="line235"></a>  var sendDeferred = goog.net.jsloader.load(uri, options);
<a name="line236"></a>
<a name="line237"></a>  // Create a deferred object wrapping the send result.
<a name="line238"></a>  var deferred = new goog.async.Deferred(
<a name="line239"></a>      goog.bind(sendDeferred.cancel, sendDeferred));
<a name="line240"></a>
<a name="line241"></a>  // Call user back with object that was set by the script.
<a name="line242"></a>  sendDeferred.addCallback(function() {
<a name="line243"></a>    var result = verifyObjs[verificationObjName];
<a name="line244"></a>    if (goog.isDef(result)) {
<a name="line245"></a>      deferred.callback(result);
<a name="line246"></a>      delete verifyObjs[verificationObjName];
<a name="line247"></a>    } else {
<a name="line248"></a>      // Error: script was not loaded properly.
<a name="line249"></a>      deferred.errback(new goog.net.jsloader.Error(
<a name="line250"></a>          goog.net.jsloader.ErrorCode.VERIFY_ERROR,
<a name="line251"></a>          &#39;Script &#39; + uri + &#39; loaded, but verification object &#39; +
<a name="line252"></a>          verificationObjName + &#39; was not defined.&#39;));
<a name="line253"></a>    }
<a name="line254"></a>  });
<a name="line255"></a>
<a name="line256"></a>  // Pass error to new deferred object.
<a name="line257"></a>  sendDeferred.addErrback(function(error) {
<a name="line258"></a>    if (goog.isDef(verifyObjs[verificationObjName])) {
<a name="line259"></a>      delete verifyObjs[verificationObjName];
<a name="line260"></a>    }
<a name="line261"></a>    deferred.errback(error);
<a name="line262"></a>  });
<a name="line263"></a>
<a name="line264"></a>  return deferred;
<a name="line265"></a>};
<a name="line266"></a>
<a name="line267"></a>
<a name="line268"></a>/**
<a name="line269"></a> * Gets the DOM element under which we should add new script elements.
<a name="line270"></a> * How? Take the first head element, and if not found take doc.documentElement,
<a name="line271"></a> * which always exists.
<a name="line272"></a> *
<a name="line273"></a> * @param {!HTMLDocument} doc The relevant document.
<a name="line274"></a> * @return {!Element} The script parent element.
<a name="line275"></a> * @private
<a name="line276"></a> */
<a name="line277"></a>goog.net.jsloader.getScriptParentElement_ = function(doc) {
<a name="line278"></a>  var headElements = doc.getElementsByTagName(goog.dom.TagName.HEAD);
<a name="line279"></a>  if (!headElements || goog.array.isEmpty(headElements)) {
<a name="line280"></a>    return doc.documentElement;
<a name="line281"></a>  } else {
<a name="line282"></a>    return headElements[0];
<a name="line283"></a>  }
<a name="line284"></a>};
<a name="line285"></a>
<a name="line286"></a>
<a name="line287"></a>/**
<a name="line288"></a> * Cancels a given request.
<a name="line289"></a> * @this {{script_: Element, timeout_: number}} The request context.
<a name="line290"></a> * @private
<a name="line291"></a> */
<a name="line292"></a>goog.net.jsloader.cancel_ = function() {
<a name="line293"></a>  var request = this;
<a name="line294"></a>  if (request &amp;&amp; request.script_) {
<a name="line295"></a>    var scriptNode = request.script_;
<a name="line296"></a>    if (scriptNode &amp;&amp; scriptNode.tagName == &#39;SCRIPT&#39;) {
<a name="line297"></a>      goog.net.jsloader.cleanup_(scriptNode, true, request.timeout_);
<a name="line298"></a>    }
<a name="line299"></a>  }
<a name="line300"></a>};
<a name="line301"></a>
<a name="line302"></a>
<a name="line303"></a>/**
<a name="line304"></a> * Removes the script node and the timeout.
<a name="line305"></a> *
<a name="line306"></a> * @param {Node} scriptNode The node to be cleaned up.
<a name="line307"></a> * @param {boolean} removeScriptNode If true completely remove the script node.
<a name="line308"></a> * @param {?number=} opt_timeout The timeout handler to cleanup.
<a name="line309"></a> * @private
<a name="line310"></a> */
<a name="line311"></a>goog.net.jsloader.cleanup_ = function(scriptNode, removeScriptNode,
<a name="line312"></a>                                      opt_timeout) {
<a name="line313"></a>  if (goog.isDefAndNotNull(opt_timeout)) {
<a name="line314"></a>    goog.global.clearTimeout(opt_timeout);
<a name="line315"></a>  }
<a name="line316"></a>
<a name="line317"></a>  scriptNode.onload = goog.nullFunction;
<a name="line318"></a>  scriptNode.onerror = goog.nullFunction;
<a name="line319"></a>  scriptNode.onreadystatechange = goog.nullFunction;
<a name="line320"></a>
<a name="line321"></a>  // Do this after a delay (removing the script node of a running script can
<a name="line322"></a>  // confuse older IEs).
<a name="line323"></a>  if (removeScriptNode) {
<a name="line324"></a>    window.setTimeout(function() {
<a name="line325"></a>      goog.dom.removeNode(scriptNode);
<a name="line326"></a>    }, 0);
<a name="line327"></a>  }
<a name="line328"></a>};
<a name="line329"></a>
<a name="line330"></a>
<a name="line331"></a>/**
<a name="line332"></a> * Possible error codes for jsloader.
<a name="line333"></a> * @enum {number}
<a name="line334"></a> */
<a name="line335"></a>goog.net.jsloader.ErrorCode = {
<a name="line336"></a>  LOAD_ERROR: 0,
<a name="line337"></a>  TIMEOUT: 1,
<a name="line338"></a>  VERIFY_ERROR: 2,
<a name="line339"></a>  VERIFY_OBJECT_ALREADY_EXISTS: 3
<a name="line340"></a>};
<a name="line341"></a>
<a name="line342"></a>
<a name="line343"></a>
<a name="line344"></a>/**
<a name="line345"></a> * A jsloader error.
<a name="line346"></a> *
<a name="line347"></a> * @param {goog.net.jsloader.ErrorCode} code The error code.
<a name="line348"></a> * @param {string=} opt_message Additional message.
<a name="line349"></a> * @constructor
<a name="line350"></a> * @extends {goog.debug.Error}
<a name="line351"></a> * @final
<a name="line352"></a> */
<a name="line353"></a>goog.net.jsloader.Error = function(code, opt_message) {
<a name="line354"></a>  var msg = &#39;Jsloader error (code #&#39; + code + &#39;)&#39;;
<a name="line355"></a>  if (opt_message) {
<a name="line356"></a>    msg += &#39;: &#39; + opt_message;
<a name="line357"></a>  }
<a name="line358"></a>  goog.net.jsloader.Error.base(this, &#39;constructor&#39;, msg);
<a name="line359"></a>
<a name="line360"></a>  /**
<a name="line361"></a>   * The code for this error.
<a name="line362"></a>   *
<a name="line363"></a>   * @type {goog.net.jsloader.ErrorCode}
<a name="line364"></a>   */
<a name="line365"></a>  this.code = code;
<a name="line366"></a>};
<a name="line367"></a>goog.inherits(goog.net.jsloader.Error, goog.debug.Error);
</pre>


</body>
</html>
